diff -Naur qcacld-2.0/CORE/HDD/src/wlan_hdd_cfg80211.c qcacld-2.0_new/CORE/HDD/src/wlan_hdd_cfg80211.c
--- qcacld-2.0/CORE/HDD/src/wlan_hdd_cfg80211.c	2017-11-16 15:06:26.159657759 +0800
+++ qcacld-2.0_new/CORE/HDD/src/wlan_hdd_cfg80211.c	2017-11-16 15:07:36.647658177 +0800
@@ -19608,15 +19608,24 @@
         return -EINVAL;
     }
 
+    if (CSR_MAX_RSC_LEN < params->seq_len)  
+    {   
+        hddLog(VOS_TRACE_LEVEL_ERROR,"%s: Invalid seq length %d", __func__, 
+                params->seq_len);   
+        return -EINVAL; 
+    }
+
+
     hddLog(VOS_TRACE_LEVEL_INFO,
-           "%s: called with key index = %d & key length %d",
-           __func__, key_index, params->key_len);
+           "%s: called with key index = %d & key length %d & seq length %d",
+           __func__, key_index, params->key_len, params->seq_len);
 
     /*extract key idx, key len and key*/
     vos_mem_zero(&setKey,sizeof(tCsrRoamSetKey));
     setKey.keyId = key_index;
     setKey.keyLength = params->key_len;
     vos_mem_copy(&setKey.Key[0],params->key, params->key_len);
+    vos_mem_copy(&setKey.keyRsc[0], params->seq, params->seq_len);
 
     switch (params->cipher)
     {
diff -Naur qcacld-2.0/CORE/MAC/inc/sirMacProtDef.h qcacld-2.0_new/CORE/MAC/inc/sirMacProtDef.h
--- qcacld-2.0/CORE/MAC/inc/sirMacProtDef.h	2017-11-16 15:03:12.375656608 +0800
+++ qcacld-2.0_new/CORE/MAC/inc/sirMacProtDef.h	2017-11-16 15:07:36.647658177 +0800
@@ -605,6 +605,7 @@
 
 /// MAX key length when ULA is used
 #define SIR_MAC_MAX_KEY_LENGTH               32
+#define SIR_MAC_MAX_KEY_RSC_LEN              16
 
 /// Macro definitions for get/set on FC fields
 #define SIR_MAC_GET_PROT_VERSION(x)      ((((tANI_U16) x) & 0x0300) >> 8)
diff -Naur qcacld-2.0/CORE/SERVICES/HIF/sdio/linux/native_sdio/src/hif.c qcacld-2.0_new/CORE/SERVICES/HIF/sdio/linux/native_sdio/src/hif.c
--- qcacld-2.0/CORE/SERVICES/HIF/sdio/linux/native_sdio/src/hif.c	2017-11-16 15:03:12.427656608 +0800
+++ qcacld-2.0_new/CORE/SERVICES/HIF/sdio/linux/native_sdio/src/hif.c	2017-11-16 17:38:02.846877544 +0800
@@ -168,7 +168,7 @@
 
 A_UINT32 nohifscattersupport = 1;
 
-A_UINT32 forcedriverstrength = 1; /* force driver strength to type D */
+A_UINT32 forcedriverstrength = 0; /* force driver strength to type D */
 
 /* ------ Static Variables ------ */
 static const struct sdio_device_id ar6k_id_table[] = {
diff -Naur qcacld-2.0/CORE/SERVICES/WMA/wma.c qcacld-2.0_new/CORE/SERVICES/WMA/wma.c
--- qcacld-2.0/CORE/SERVICES/WMA/wma.c	2017-11-16 15:04:53.103657206 +0800
+++ qcacld-2.0_new/CORE/SERVICES/WMA/wma.c	2017-11-16 15:07:36.671658177 +0800
@@ -19573,6 +19573,8 @@
 	cmd->key_ix = key_params->key_idx;
 	WMI_CHAR_ARRAY_TO_MAC_ADDR(key_params->peer_mac,
 				   &cmd->peer_macaddr);
+    vos_mem_copy(&cmd->key_rsc_counter,
+                    &key_params->key_rsc[0], sizeof(uint64_t));
 	if (key_params->unicast)
 		cmd->key_flags |= PAIRWISE_USAGE;
 	else
@@ -19703,6 +19705,9 @@
 		 key_params->key_idx, key_params->key_type, key_params->key_len,
 		 key_params->unicast, key_params->peer_mac,
 		 key_params->def_key_idx);
+    WMA_LOGD("keyrsc param key_seq_counter_h:0x%x key_seq_counter_l: 0x%x", 
+        cmd->key_rsc_counter.key_seq_counter_h, 
+        cmd->key_rsc_counter.key_seq_counter_l);
 
 	return buf;
 }
@@ -19776,6 +19781,9 @@
 			key_params.key_idx = key_info->key[i].keyId;
 
 		key_params.key_len = key_info->key[i].keyLength;
+        vos_mem_copy(key_params.key_rsc,
+            key_info->key[i].keyRsc,
+            SIR_MAC_MAX_KEY_RSC_LEN);
 		if (key_info->encType == eSIR_ED_TKIP) {
 			vos_mem_copy(key_params.key_data,
 				     key_info->key[i].key, 16);
diff -Naur qcacld-2.0/CORE/SERVICES/WMA/wma.h qcacld-2.0_new/CORE/SERVICES/WMA/wma.h
--- qcacld-2.0/CORE/SERVICES/WMA/wma.h	2017-11-16 15:03:12.447656608 +0800
+++ qcacld-2.0_new/CORE/SERVICES/WMA/wma.h	2017-11-16 15:07:36.671658177 +0800
@@ -1401,6 +1401,7 @@
 	u_int32_t key_idx;
 	bool unicast;
 	u_int8_t key_data[SIR_MAC_MAX_KEY_LENGTH];
+    u_int8_t key_rsc[SIR_MAC_MAX_KEY_RSC_LEN];
 };
 
 typedef struct {
